/*! \file "dir.h" \brief Directory-Definitions */
///	\ingroup DIR
//#########################################################################
//
//#########################################################################
// Last change: 24.08.2007
//#########################################################################
// Compiler: AVR-GCC 4.1.1
//#########################################################################
//@{

#ifndef __DIR_H
#define __DIR_H

extern U8 Mkdir(char *name);
extern U8 Chdir(char *name);
extern U8 MakeNewFileEntry(char fileid);
extern U8 UpdateFileEntry(char fileid);
//extern U16 DOSTime(void);
//extern U16 DOSDate(void);

extern U8 ScanOneDirectorySector(char fileid, U32 sector);

#ifdef USE_FAT32
// extern U8 SearchFreeDirentry(char fileid, U32 cluster);
 extern U8 ScanDirectory(char fileid, U32 startcluster);
#else
// extern U8 SearchFreeDirentry(char fileid, U16 cluster);
 extern U8 ScanDirectory(char fileid, U16 startcluster);
#endif

extern U8 SearchDirSector(char fileid, U32 sector);

extern void MakeDirEntryName(char *inname, char fileid);
extern void ZeroCluster(U32 startsector);

#define ls()	FindName(-1)

extern U8 dirbuf[];   //buffer for directory sectors

#ifdef USE_FAT32
 extern U32 FirstDirCluster;
#else
 extern U16 FirstDirCluster;
#endif


#endif //__DIR_H
//@}
