//###########################################################
// File: readraw.c
//
// Benutzung auf eigene Gefahr !
//
// Use at your own risk !
//
//#########################################################################
// Last change: 15.10.2006
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: avr-gcc 3.4.5
//#########################################################################
//@{
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dos.h"

#ifdef DOS_READ_RAW
//###########################################################
// reads all clusters/sectors of the file.
// you have to check FileSize from direntry to see how
// many bytes of last cluster are valid for the file. 
// much faster than fread()
unsigned char ReadFileRaw(char *name)
//###########################################################
{
 U32 tmpsector;

#ifdef USE_FAT32
 U32 tmp;
#else
 U16 tmp;
#endif

 unsigned char *p;
 unsigned char by,secloop;
 U16 i;
 char fileid;
 struct FileDesc *fdesc;
 unsigned char end_of_file_is_near;

 fileid=findfreefiledsc();
 
 if(fileid==-1) return F_ERROR; // there are too many open files !

 fdesc=&FileDescriptors[(U16)fileid];

 MakeDirEntryName(name,fileid);

 if(FindName(fileid)==FULL_MATCH)
  {
   tmp=fdesc->FileFirstCluster;
   fdesc->FilePosition=0;         //actual read position
  
   while(tmp < endofclusterchain) // read all clusters of file
    {
     tmpsector=GetFirstSectorOfCluster(tmp);

     // read all sectors of this cluster
     for(secloop=0; secloop<secPerCluster; secloop++)
      {
       ReadSector(tmpsector,fdesc->iob);
       p=fdesc->iob;          //pointer to io buffer

       if((fdesc->FileSize-fdesc->FilePosition) > BYTE_PER_SEC) end_of_file_is_near = 0;
       else end_of_file_is_near=1;

       // read data from iob now
       for(i=0; i<BYTE_PER_SEC; i++) // read all bytes of a sector
        {
         by=*p++; // get a byte from iob
         // 'by' holds your data now. use it as you want 
         // put your function to use 'by' below

         //****************************
         // load your MP3-Chip here ;)
         //****************************

         // end of your function
         
         if(end_of_file_is_near)
          {
           fdesc->FilePosition++; // count bytes read
           if(fdesc->FilePosition>=fdesc->FileSize) 
            {
              fdesc->FileFlag=0;
              return (fileid+1);
            
              // if F_ERROR is defined with value 0
              // then we can use this trick (+1) to tell the caller that is F_OK
              // and where to find a filesize (dosreadraw1.c)
            
            } // end of file reached ?
          } 
        } 

       tmpsector++; // next sector of cluster
      }// for(secloop=0; secloop<secPerCluster; secloop++)

     fdesc->FilePosition += BYTE_PER_SEC;
       
     tmp=GetNextClusterNumber(tmp);
    }// while(tmp < endofclusterchain)

  }//if(FindName(name)==FULL_MATCH)
 else 
  {
   fdesc->FileFlag=0;
   return F_ERROR;  // something went wrong
  }

 fdesc->FileFlag=0;
 
 return (fileid+1);
}
#endif
//@}
